
<%--
  The Program materials contained in this file are IBM copyright materials.
  COPYRIGHT International Business Machines Corp. 2014
  All Rights Reserved * Licensed Materials - Property of IBM
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 --%>

<%@ page session="false" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" %>
<%@ page import="java.util.Iterator"%>
<%@ page import="java.io.BufferedReader"%>
<%@ page import="java.io.IOException"%>
<%@ page import="java.io.InputStreamReader"%>
<%@ page import="java.io.OutputStreamWriter"%>
<%@ page import="java.net.*"%>

<!DOCTYPE html>
<html style="height: 100%; width: 100%; margin: 0px; padding: 0px;">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta name="DC.Rights" content="Â© Copyright IBM Corp. 2014" />
<meta name="viewport" content="width=device-width,initial-scale=1"/>
<meta http-equiv="X-UA-Compatible" content="IE=edge"/>

<link href="login/images/favicon.ico" rel="icon" />
<link href="login/images/favicon.ico" rel="shortcut icon" />
<link href="login/images/apple-touch-icon.png" rel="apple-touch-icon" />
<link rel="stylesheet" href="dojo/resources/dojo.css" />
<link rel="stylesheet" href="dijit/themes/dijit.css" />
<link rel="stylesheet" href="idx/themes/oneui/oneui.css" />

<link rel="stylesheet" href="css/toolbox.css" />

<script>
	var BIDI_PREFS_STRING = '{"bidiEnabled":false,"bidiTextDirection":"ltr"}';
</script>
<%
    response.setHeader("Content-Type", "text/html; charset=UTF-8");
    String hasBidi = "";       // used to initialize dojo
    String userId = request.getRemoteUser();     // passed to widgets
//    String userLocale = request.getLocale().toString().replace('_', '-').toLowerCase();
    // TODO: In newer browsers, the lang could have a variant which is not handled by dojo. ex. zh-hant-tw
    // So, construct a "normal" lang-country from the locale
    // TODO: for some reason, getVariant() is returning the country so for now ...
    String userLocale = request.getLocale().getLanguage().toLowerCase();
    if (request.getLocale().getVariant().length() > 0) {
        userLocale += "-" + request.getLocale().getVariant().toLowerCase();
    } else if (request.getLocale().getCountry().length() > 0) {
        userLocale += "-" + request.getLocale().getCountry().toLowerCase();
    }
    String dojoConfigString = "locale: '" + userLocale + "'";
    //System.out.println("setting dojolocale:" + dojoConfigString);
    
    String urlString = request.getRequestURL().substring(0, request.getRequestURL().indexOf(request.getContextPath()));
    urlString = urlString + "/ibm/api/adminCenter/v1/toolbox/preferences";
    HttpURLConnection connection = null;
    BufferedReader rd  = null;
    CookieManager cm = new CookieManager();
    CookieHandler.setDefault(cm);
    if ( request.getCookies() != null ) {
	    for (int i = 0; i < request.getCookies().length; i++){
	        cm.getCookieStore().add(new URI(request.getRequestURI()), new HttpCookie(request.getCookies()[i].getName(),request.getCookies()[i].getValue()));
	    }
    }
    StringBuffer sb = new StringBuffer();
    for (Iterator iter = cm.getCookieStore().getCookies().iterator(); iter.hasNext(); ){
        if (sb.length() == 0){
            sb.append(iter.next());
        } else {
            sb.append("," + iter.next());
        }
    }
    URL serverURL = null;
    try {
        serverURL = new URL(urlString);
        //set up out communications stuff
        connection = null;
        
        //Set up the initial connection
        connection = (HttpURLConnection)serverURL.openConnection();
        connection.setRequestProperty("Cookie", sb.toString());
        connection.setRequestMethod("GET");
        connection.setDoOutput(true);
        connection.setReadTimeout(10000);
        connection.connect();
        
        //read the result from the server
        rd  = new BufferedReader(new InputStreamReader(connection.getInputStream()));
        
        String line = null;
        while ((line = rd.readLine()) != null){
            // this should be one line like this: {"bidiEnabled":true,"bidiTextDirection":"ltr"}
%>
<script>
BIDI_PREFS_STRING = '<%=line%>';
</script>
<%
            if (line.indexOf("\"bidiEnabled\":true") != -1){
                hasBidi = "has:{'adminCenter-bidi': true, 'dojo-bidi': true}"; 
                //System.out.println("Bidi is enabled for the UI application with properties:" + hasBidi);
%>
        <link rel="stylesheet" href="dijit/themes/dijit_rtl.css" />
<%                
            }
        }
        if (hasBidi.length() > 0){
            dojoConfigString = dojoConfigString + ", " + hasBidi;
        }
                    
    } catch (MalformedURLException e) {
        // just default to no bidi
        //e.printStackTrace();
    } catch (ProtocolException e) {
        // just default to no bidi
        //e.printStackTrace();
    } catch (IOException e) {
        // just default to no bidi
        //e.printStackTrace();
    }
    finally
    {
        // clean up: close the connection
        connection.disconnect();
        rd = null;
        sb = null;
        connection = null;
    }
%>

<script src="dojo/dojo.js" data-dojo-config="<%=dojoConfigString%>"></script>
<script>console.log("<%=dojoConfigString%>");</script>
<script>require(["js/loadToolbox"])</script>

 
<title id="toolbox_tab_title"></title>

</head>

<body class="oneui" style="height:100%; width:100%; padding-top: 0px;">
  <noscript>
    <div>
      <h2>Admin Center requires JavaScript. JavaScript is currently disabled.</h2>
      <h2>Enable JavaScript or use a browser which supports JavaScript.</h2>
    </div>
  </noscript>
  <div data-dojo-type="idx/app/A11yPrologue"></div>
  <div id="mainContainer" class="mainContainer" style="height:100%; width:100%">

    <!-- dojox.mobile.ScrollableView with fixed="top" attribute on toolbox_headerWidget allows filter box and icons to scroll up,
          underneath "My Toolbox". Can't use that type, but dojox.mobile.View is not allowing the desired behavior --> 
    <!-- Hard code the aria-label for the headers to English here. This prevents the RPT violation. Note the actual value when
         the specific view is displayed is set programmatically in LibertyHeader.js.  -->
    <div id='toolboxContainer' data-dojo-type="dojox.mobile.View" data-dojo-props=" 
             style: 'width: 100%; margin: auto;'">
      <div data-dojo-type="js/widgets/LibertyHeader" id="toolBox_headerWidget" containerId="toolboxContainer" userName="<%=userId%>" aria-label="Toolbox"> 
      </div> <!-- end of header -->
      <ul data-dojo-type="js/widgets/LibertyToolbox" id="toolIconContainer" role="main"/> 
      <div id="addBookmarkDialogId" ></div>
    </div> <!-- end of contentPane -->
 
    <div id='catalogContainer' data-dojo-type="dojox.mobile.View" data-dojo-props="style: 'width: 100%; height: 100%; margin: auto;'">
      <div data-dojo-type="js/widgets/LibertyHeader" id="catalog_headerWidget" containerId="catalogContainer" userName="<%=userId%>" aria-label="Tool catalog"> 
      </div> <!-- end of header -->
      <ul data-dojo-type="js/widgets/LibertyCatalog" id="catalogIconContainer" role="main"/> 
    </div> <!-- end of contentPane -->

    <div id='bgTasksContainer' data-dojo-type="dojox.mobile.View" data-dojo-props="style: 'width: 100%; height: 100%; margin: auto; background-color: #F8F8F7'">
      <div data-dojo-type="js/widgets/LibertyHeader" id="bgTasks_headerWidget" containerId="bgTasksContainer" userName="<%=userId%>" aria-label="Background tasks"> 
      </div> <!-- end of header -->
      <div data-dojo-type="js/widgets/BGTasks" id="bgTasksTreeContainer" role="main"></div>
      <div style="clear: both"></div>
      <div style="height: 15px;width: 100%"></div>
      <div id="bgTasksTreeView"></div> 
    </div> <!-- end of contentPane -->


    <div id='toolContainer' data-dojo-type="dojox.mobile.View" data-dojo-props="style: 'width: 100%; height: 100%; margin: auto; overflow: hidden;'">
      <div data-dojo-type="js/widgets/LibertyHeader" id="tool_headerWidget" containerId="toolContainer" userName="<%=userId%>" aria-label="Tool"></div>
      <div id='toolContentContainer' class='toolContentContainerDiv'></div>
    </div>

    <div id='prefsContainer' data-dojo-type="dojox.mobile.View" data-dojo-props="style: 'width: 100%; height: 100%; margin: auto;'">
      <div data-dojo-type="js/widgets/LibertyHeader" id="prefs_headerWidget" containerId="prefsContainer" userName="<%=userId%>" aria-label="Preferences"></div>
      <div data-dojo-type="js/widgets/LibertyPrefs" class="profile-container" id="prefsContentContainer" role="main" userName="<%=userId%>" style="width: 100%; height: 100%;"></div>
    </div>            

    <div id='toolDetailContainer' data-dojo-type="dojox.mobile.View" data-dojo-props="style: 'width: 100%; height: 100%; margin: auto;'">
      <div data-dojo-type="js/widgets/LibertyHeader" id="details_headerWidget" containerId="toolDetailContainer" userName="<%=userId%>" aria-label="Tool details"></div>
      <div data-dojo-type="js/widgets/ToolDetails" class="profile-container" id="toolDetailContentContainer" role="main" userName="<%=userId%>" style="width: 100%; height: 100%;"></div>
    </div>
  </div>
</body>
</html>
